;
;	File:	color1p.bin
;
;	CPU:	Zilog Z80 (Z80 family)
;
;
.org	0000h
;
	jp	L02B9		; RESET belpsi pont
;
;
;       LUT feltltshez hasznlt cmkdok:
;       - a fels 6 bit hasznlt
;	- a 2-3.bitet a fels 4-tl kln kezeli a HW, 2.bit=2^5  3.bit=2^4 
;	- a 3.bit invertlva kerl a LUT cmbemenetre
;	- egy paletta cmzsekor 2-vel nvekszik a cmz R reg. rtke
;	- a 2-bjtos cmkdok tfedik egymst
;	- cmzsi sorrend: LUTad0 ->8cm; LUTad1 ->16cm; LUTad2 ->16cm; LUTad3 ->16cm; LUTad4 ->8cm
;	- valsznleg az INT cme miatt (0038h) kezddtt a tblzat a 0x0008 cmen az eredeti kdban
;
;
.org	0008h
LUTad0:	.db	08h,00h,18h,00h,28h,00h,38h,00h,48h,00h,58h,00h,68h,00,78h
LUTad3:	.db	8Ch
LUTad1:	.db	88h,9Ch,98h,0ACh,0A8h,0BCh,0B8h,0CCh,0C8h,0DCh,0D8h,0ECh,0E8h,0FCh,0F8h,04h
	.db	00h,14h,10h,24h,20h,34h,30h,44h,40h,54h,50h,64h,60h,74h,70h,00h
;
.org	0038h
	jp	L02B9		; INT belpsi pont
;
;       LUT cmtblzat folytatsa
;
.org	0040h
LUTad2:	.db	80h
LUTad4:	.db	84h,90h,94h,0A0h,0A4h,0B0h,0B4h,0C0h,0C4h,0D0h,0D4h,0E0h,0E4h,0F0h,0F4h
	.db	0Ch,00h,1Ch,00h,2Ch,00h,3Ch,00h,4Ch,00h,5Ch,00h,6Ch,00,7Ch,00h
;
;
.org	0066h			; NMI belpsi pont
;
;
; 31 sor + 3 sor kpkiolts
;
;
	ld	(hl),$7B	; sttuszregiszter=0x7B -> NMICL=1 -> WAIT ciklusok, rszinkronizl HBL=0-ra
	ld	de,$5A58	; +10 DE=sttuszba rand rtkek
	ld	bc,$521A	; +10 BC=sttuszba rand rtkek
	ld	hl,$9053	; +10 H=90h cm a sttusz reg.-hez, L=0x53 -> ST4=0->32 szn(eredetileg:L=0x5B)
	exx			; +4
	ld	hl,$9FFF	; +10
	ld	sp,hl		; +6
	ld	b,$22		; +7 34 sor lesz a ciklusban
L0078:
	ld	($8000),de	; +20 raciklus, 240 raciklus egy sor
	add	hl,de		; +11 raciklus
	ld	a,b		; +4
	exx			; +4
	cp	$04		; +7  az utols 4-ben ms rtke lesz L reg.nek
	jp	z,L00A9		; +10 ugrs-> L=L-1 =>CBL=0 kpkiolts kezdete
	exx			; +4
	dec	b		; +4
	jp	z,L00AF		; +10 ha vge az els 34 sornak, ugrs
	nop			; +4
L008A:
	ld	($8000),de	; +20 raciklus
	exx			; +4
	ld	(hl),d		; +7  sttusz reg.=0x5A -> CBL=0 - sorkiolts
	ld	(hl),e		; +7  sttusz reg.=0x58 -> CSYNC=0 - sorszinkron
	ld	r,a		; +9
	push	bc		; +11 SP=9FFFh, majd SP=SP-2, ez is a sttuszt rja 
	nop			; +4  0x52->sorszinkron vge, majd 0x1A->BG=1->0 (s ST4-et is 0->1)
	ld	(hl),d		; +7 sttusz = 0x5A BG=1
	ld	(hl),l		; +7 sttusz = 0x5B CBL=1 
	exx			; +4
	ld	($8000),de	; +20
	ld	($8000),de	; +20
	ld	($8000),de	; +20
	ld	hl,$0000	; +10
	jr	L0078		; +12 = 240 raciklus
;
L00A9:
	dec	l		; +4 L reg. cskkentse a kpkioltshoz a 31.sortl
	exx			; +4
	dec	b		; +4
	jp	L008A		; +10
;
;
; 3 soridnyi kpszinkron,
; paletta idzt szmll cskkentse,
; kvetkez aktv palettra lls, ha mr lejrt az aktulis idztse
; ha figyelemfelhvs bit=1, a legkisebb sorszm aktv paletta idztst tlti be  
;
;
L00AF:				; 35. TV sortl
	ld	b,$03		; +7  3 soros ciklus lesz?
	exx			; +4
	ld	d,$50		; +7
	ld	(hl),l		; +7  sttusz =0x5B -> CBL=0 - kpkiolts 
	ld	a,e		; +4
	ld	($9000),a	; +7  sttusz =0x58 -> CSYNC=0 - kpszinkron?
	ld	a,r		; +9
	push	de		; +11 sttusz =0x5A, majd 0x58
	exx			; +4
	ld	a,($C021)	; +13 olvass a RAM 33. cmrl (paletta-kijell bjt)
	rlca			; figyelem felhvs bit?
	jp	nc,L0105	; ugrs, ha nem (kzvetett ugrs L00C7-re +10 raciklussal, reset utn DE=0101h)
	ld	de,$0104	; +10 D=idzts szmll E=aktulis paletta (1,2,4)
L00C7:
	ld	c,e		; C=4 ha figyelemfelhvs, egybknt C=eredeti aktulis paletta
	dec	d		; D=D-1 idzts cskkentse
	rrca			; A reg. visszaforgatsa
	ex	af,af'		; A reg. mentse
L00CB:				; ciklus kezdete
	ld	a,c		; aktulis paletta sorszmnak nvelse, az idztstl fggetlenl
	cp	$04		; kisebb 4-nl? (nincs figyelemfelhvs, nem utols paletta volt)
	jp	c,L0108		; ugrs, ha igen (C balralptetse 1-gyel, folytats L00D6-on)
	ld	a,$01		; +7
	ld	a,$01		; +7
	ld	c,a		; +4  C=1
L00D6:
	ld	hl,$C026	; HL a 3.paletta(?) idztse utni bjtra mutat
	ld	a,l		; A=0x26
	sub	c		; C rtkvel cskkenti a bziscmet (1 bjt kimarad az 1.(?) s 2. paletta idzts kztt!!!)
	ld	l,a		; HL=0xC026 - C reg.
	ld	a,d		; D=paletta htralev idztse
	or	a
	ld	l,(hl)		; +7  olvass a RAM kiszmtott cmrl (C-vel adott paletta idztse)
	ex	af,af'		; +4  A'=paletta kijell bjt
	ld	h,a		; +4  A' msolsa H-ba (paletta-kijell bjt)
	ex	af,af'		; +4  vissza az eredeti A-hoz
	ld	a,h		; +4  A=paletta kijell bjt
	jr	nz,L010D	; +7/12 ugrs, ha D<>0, nem jrt le az idzts, vagy mr betlttte a kvetkez aktv paletta idztst (folytats L00EA-n, +14 raciklussal)
	and	c		; +4  a C ltal mutatott paletta aktv?
	jr	z,L0111		; +7/12 ugrs, ha nem (folytats L00EC-n, +10)
	ld	d,l		; +4  D=a kijellt paletta idztse
	ld	e,c		; +4  E=a kijellt paletta rel. cme (s maszkja)
L00EA:
	ld	h,$00		; +7 raciklus
L00EC:
	inc	hl		; +6 raciklus
	dec	b		; +4  ciklusszmll cskkentse
	exx			; +4
	ld	(hl),l		; +7  sttusz =0x5B -> CBL=0 - kpkiolts 
	jp	z,L011B		; +10 B=0? vge a kpszinkronnak, DE'=az aktv paletta idztse s rel. cme
	ld	(hl),e		; +7  sttusz reg.=0x58 -> CSYNC=0 - kpszinkron
	ld	a,r		; +9
	push	de		; +11 sttusz =0x5A, majd 0x58 - mg mindig kpszinkron
	exx			; +4
	ld	a,($0000)	; +13
	ld	($8000),de	; +20
	ld	hl,$0000	; +10
	jp	L00CB		; +10
L0105:
	jp	L00C7		; +10
;
L0108:
	sla	c		; +8  C reg. balralptetse 1-gyel, aktv paletta maszk
	jp	L00D6		; +10
;
L010D:
	nop			; +4
	jp	L00EA		; +10
L0111:
	jp	L00EC		; +10
;
;
; 5 sor kpkiolts (eredetileg 3 sor),
; LUT belltsa az aktulis palettra, ha az idztse nem nulla
;
;
L0114:
	ld	d,$01		; +7
	ld	h,$C0		; +7  a RAM-ot olvassra jelli ki, de tiltja a LUT rst
	jp	L0134		; +10
;
L011B:				; 38. TV sortl
	ld	(hl),e		; +7  sttusz reg.=0x58 -> CSYNC=0 - kpszinkron
	ld	a,r		; +9
	push	bc		; +11  0x52->kpszinkron vge, majd 0x1A->BG=1->0 (ST4!!!)
	nop			; +4
	ld	(hl),l		; +7  sttusz =0x5B -> CBL=0 - kpkiolts
	ld	d,$4E		; +7
	ld	(hl),d		; +7  sttusz =0x4E -> MPX=0  BRD=1 ST4=1
	exx			; +4
	xor	a		; +4  A=0
	ld	i,a		; +9  frisstskor A15..A8-on I reg. tartalma jelenik meg
	ld	hl,L02C8-1	; paletta cmtblzat kezdcme a ROM-ban -1
	ld	b,a		; +4  B=0
	or	d		; +4  az aktv paletta idztse=0?
	jr	z,L0114		; +7/12 ugrs, ha igen (D=1 H=0xC0->nem rja a LUT-ot, folytats L0134-en, +28)
	ld	c,e		; +4  BC=aktv paletta rel. cme
	add	hl,bc		; tblzatbeli cm
	ld	l,(hl)		; adat betltse a tblzatbl (adott paletta cme a RAM-ban?)
	ld	h,$D0		; a RAM-ot olvassra, a LUT-ot rsra jelli ki
L0134:
	ld	a,LUTad0	; a ROM-ban 0008h-n kezddnek a LUT cmkdok
	ld	r,a		; frisstskor A6..A0-n R reg tartalma jelenik meg,ROM->LUT cm
	ld	a,(hl)		; paletta bjt olvassa a RAM-bl, rsa a LUT-ba, R++
	inc	l		; RAM cm nvelse, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; 8 paletta bjt msolsa a LUT-ba
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,r		; ROM cm mentse (nincs hatsa)
	exx
	ld	(hl),e		; +7  sttusz =0x58 -> CSYNC=0 - sorszinkron
	ld	a,r		; +9
	push	bc		; +11 sttusz 0x52->soszinkron vge, majd 0x1A->BG=1->0 (+ST4!!!)
	nop			; +4
	ld	(hl),d		; +7  sttusz =0x4E -> MPX=0  ST4=1  BRD=1, BG=1
	exx
	ld	a,LUTad1
	ld	r,a		; R reg. belltsa, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; paletta bjt olvassa a RAM-bl, rsa a LUT-ba, R++
	inc	l		; RAM cm nvelse, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; 16 paletta bjt msolsa a LUT-ba
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	hl
	exx			; sorszinkron
	ld	(hl),e
	ld	a,r
	push	bc
	nop
	ld	(hl),d		; +7  sttusz =0x4E -> MPX=0  ST4=1  BRD=1, BG=1
	exx
;
; tovbbi kt teljes paletta tlt sor a 64 szn mdhoz
;
	ld	a,LUTad2
	ld	r,a		; R reg. belltsa, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; paletta bjt olvassa a RAM-bl, rsa a LUT-ba, R++
	inc	l		; RAM cm nvelse, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; 16 paletta bjt msolsa a LUT-ba
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	hl
	exx			; sorszinkron
	ld	(hl),e
	ld	a,r
	push	bc
	nop
	ld	(hl),d		; +7  sttusz =0x4E -> MPX=0  ST4=1  BRD=1, BG=1
	exx
	ld	a,LUTad3
	ld	r,a		; R reg. belltsa, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; paletta bjt olvassa a RAM-bl, rsa a LUT-ba, R++
	inc	l		; RAM cm nvelse, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; 16 paletta bjt msolsa a LUT-ba
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	hl
	exx			; sorszinkron
	ld	(hl),e
	ld	a,r
	push	bc
	nop
	ld	(hl),d		; +7  sttusz =0x4E -> MPX=0  ST4=1  BRD=1, BG=1
	exx
;
	ld	a,LUTad4
	ld	r,a		; R reg. belltsa, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; paletta bjt olvassa a RAM-bl, rsa a LUT-ba, R++
	inc	l		; RAM cm nvelse, kvetkez LUT cm a ROM-bl, R++
	ld	a,(hl)		; utols 8 paletta bjt msolsa a LUT-ba
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	ld	a,(hl)
	inc	l
	exx
	ld	d,$5A		; MPX=1  BRD=0  ST4=1
	exx
;
;
; tovbbi 12 sorra a kpkiolts
; (eredetileg 15 sor, 2 sor ment a paletta belltshoz, 1 sor a 64 szn md vizsglathoz)
;
;
	ld	b,$0D		; 12 TV soros ciklus (a 13. sorszinkronnl fejezi be)
L0198:
	ld	($8000),de
	ld	($8000),de
	ld	($8000),de
	nop
	nop
	exx			; sorszinkron
	ld	(hl),e
	ld	a,r		; +9
	push	bc		; +11
	nop			; +4
	ld	(hl),d		; +7
	exx			; +4
	jr	L01B0		; +12
;
L01B0:
	dec	b		; +4
	jp	z,L01CB		; +10 vge a 12 TV sornak, a 13. sorszinkron kiadva (16.sor eleje - 61 ciklus)
	ld	h,$00
	nop
	ld	($8000),de
	ld	($8000),de
	ld	($8000),de
	ld	hl,$0000
	ld	a,r
	jp	L0198
;
;
; 1 sor, zemmd vizsglata (165 ciklus)
;
;
L01CB:
	ld	hl,$9202	; +10
	ld	sp,hl		; +6  SP csak szinkronnl kell
	ld	a,($C020)	; +13 vezrlbjt olvassa a RAM-bl
;
	and	$0E		; +7  vezrl bitek maszkolsa, 3.bit=64 szn md
	ld	hl,IY_TABLA	; +10 tblzat cme a ROM-ban
	ld	b,$00		; +7
	ld	c,a		; +4
	add	hl,bc		; +11 tblzat beli cm az zemmdnak megfelelen
	ld	c,(hl)		; +7  BC-be a sormegjelent szubrutin cme
	inc	hl		; +6
	ld	b,(hl)		; +7
	ld	iy,0000		; +14
	add	iy,bc		; +15 IY-ban az zemmdnak megfelel cm
	nop			; +4
	nop			; +4
	nop			; +4
	nop			; +4
;
	ld	hl,$E01D	; +10 H=0xE0 -> fogad reg. kimenet eng., RAM rs eng.
	ld	a,l		; +4  A reg.=RAM rs kezdcme-3
	exx			; +4  vlts a szinkron kiadshoz
	nop			; +4
	jp	TESZT64c	; +10 ugrs a szinkronhoz
;
;
; tovbbi 1 TV sor a 64 szn zemmd vizsglathoz
;
;
TESZT64c:
	ld	(hl),d		; +7
	ld	(hl),e		; +7
	ld	a,r		; +9
	push	bc		; +11
	nop			; +4
	ld	(hl),d		; +7  (innen 202 ciklus kell)
	exx			; +4
;
	nop			; +4  (kitlts: 8db nop = 32 ciklus)
	nop			; +4
	nop			; +4
	nop			; +4
	nop			; +4
	nop			; +4
	nop			; +4
	nop			; +4
;
	ld	hl,$9202	; +10
	ld	sp,hl		; +6  SP csak szinkronnl kell-> 256. sor utn nem ad ki BG jelet -> elveszti a kpszinkront(?)
;
	ld	a,($C020)	; +13 vezrlbjt olvassa a RAM-bl (hasznos rsz: 143 ciklus)
	and	$06		; +7  vezrl bitek maszkolsa
	ld	hl,L02CC	; +10 tblzat cme a ROM-ban
	ld	b,$00		; +7
	ld	c,a		; +4
	add	hl,bc		; +11 tblzat beli cm az zemmdnak megfelelen
	ld	b,(hl)		; +7  BC-be tlttt rtk a kpelem def. alapjn:
	inc	hl		; +6  0,4,5 (4*4) - BC= 0x3704     6 (6*9) - BC= 0x1E09
	ld	c,(hl)		; +7  2,3   (6*6) - BC= 0x2706
				; B= szninformcis sorok szma-1 (az utols sort nem a ciklusban olvassa be), C= egy blokk magassga
	ld	hl,$E01D	; +10 H=0xE0 -> fogad reg. kimenet eng., RAM rs eng.
	ld	a,($C020)	; +13 vezrlbjt olvassa a RAM-bl
	bit	3,a		; +8  a 64 szn md vizsglata 4*4-es mdhoz
	ld	a,l		; +4  A reg.=RAM rs kezdcme-3
	exx			; +4  vlts a szinkron kiadshoz
	jp	z,TESZT64c_1	; +10 ha nulla, 32 szn
	inc	l		; +4  kpkiolts vge: CBL=1
	set	3,l		; +8  64 szn lesz 4*4-es mdban
	jp	L0222		; +10 ugrs a szinkronhoz, ZF=NZ
;
TESZT64c_1:
	inc	l		; +4  kpkiolts vge: CBL=1
	res	3,l		; +8  32 szn lesz 4*4-es mdban
	jp	L0222		; +10 ugrs a szinkronhoz, ZF=NZ
;
;
; vezrl sor, paletta- s sznbjtok beolvassa a RAM-ba
; B reg.-ben adott szm sor hosszsgban
; az olvasott bjtok szma mindig kisebb mint 2kB (max. 1792 bjt)
;
;
L01F8:				
	ld	r,a		; +9  R=L reg.=0x1D
	ld	a,h		; +4  R++ (R=0x1E)
	ld	i,a		; +9  I=H s R=L reg. , IR=0xE020->a RAM 0x0020 cmtl trol, 0. sznbjt
	xor	a		; +4  1. sznbjt, kzben a kv. sor RAM cmnek kiszmtsa
	set	5,a		; +8  2. s 3. sznbjt, A reg.=32
	add	a,l		; +4  4. sznbjt, A reg.=elz sor cme(-3) + 32
	ld	l,a		; +4  5. sznbjt, L= kv. sor cme als bjt
	adc	a,h		; +4  6. sznbjt, tvitel s H hozzadsa A-hoz
	sub	l		; +4  7. sznbjt, A reg. korbbi rtknek kivonsa
	ld	h,a		; +4  8. sznbjt, H= kv. sor cme fels bjt
	nop			; +4  tovbbi 20 sznbjt olvassa
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	res	5,a		; +8  29. s 30. sznbjt, elkszlet a RAM rs tiltshoz
	ld	i,a		; +9  31. sznbjt, RAM rs tiltsa (A13=0)
	ld	a,r		; +9  ciklus
	ld	a,l		; +4  A reg.=a kvetkez cm als bjtja 
	dec	b		; +4  beolvasand sznes sorok szmlljnak cskkentse
	exx			; +4  sorszinkron
L0222:
	ld	(hl),d		; +7
	ld	(hl),e		; +7
	ld	r,a		; +9
	push	bc		; +11
	nop			; +4  (L0222-tl: 38 ciklus)
	ld	(hl),d
	ld	(hl),l		; CBL=1, innen szmtva 34 raciklusra rkezik az els sznbjt
	exx			; +4
	jr	nz,L01F8	; +12/+7 ismtls, amg B>0
	ret	nz		; +5  biztos nem Z, csak kitlt raciklus
	ld	r,a		; +9  ez a beolvasand utols sor kezdete
	ld	a,h		; +4
	ld	i,a		; +9  IR megint a RAM-ot cmzi rsra, 0. sznbjt
	ld	b,c		; +4  1. sznbjt, B= egy blokk magassga (4,6,9)
	xor	a		; +4  2. sznbjt
	ld	h,a		; +4  3. sznbjt
	set	7,h		; +8  4. s 5. sznbjt
	set	6,h		; +8  6. s 7. sznbjt, H=0xC0
	cpl			; +4  8. sznbjt, A reg.=0xFF
	ld	l,a		; +4  9. sznbjt
	res	6,l		; +8  10. s 11. sznbjt
	res	5,l		; +8  12. s 13. sznbjt, L=0x9F-> '5.sor' kezd RAM cme-1
	exx			; +4  14. sznbjt
	set	2,l		; +8  15. s 16. sznbjt, BD=1 (majd a szinkron alatt rja be)
	exx			; +4  17. s 18. sznbjt
	ld	a,l		; +4  19. sznbjt
	ex	af,af'		; +4  20. sznbjt, A'= sznbjtok kezdete a RAM-ban, als bjt
	nop			; +4  tovbbi 10 sznbjt
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ld	a,h		; +4  31. sznbjt, A= els sznbjt RAM cmnek fels bjtja
	ld	i,a		; +9  32. piszok bjt, RAM rs kikapcsolsa, olvass eng.		
	ld	i,a		; +9  ciklus
	exx			; +4
	jp	(iy)		; +8  ugrs a mdnak megfelel cmre
;
;
;      6*n -es blokkmret 32 szn mdok megjelentsi fciklusa
;
;
L0258:
	ld	(hl),d		; 6-os blokkmret ciklusok, ismtls NMI rkezsig
	ld	(hl),e
	ld	i,a		; RAM olvass elkszts, I=cm fels bjt
	push	bc
	ex	af,af'		; A reg.= RAM cm als bjt
	ld	(hl),d
	ld	(hl),l
	ret	c
	ld	r,a
	ld	(hl),$D7	; 6/4=1 -> 6-os mdnak megfelel raciklus, ST4=0
	exx
	xor	a
	dec	b
	cp	b
	ccf
	rra
	rra
	rra
	add	a,l
	ld	l,a
	adc	a,h
	sub	l
	ld	h,a
	ex	af,af'
	xor	a
	cp	b
	ccf
	sbc	a,a
	and	c
	or	b
	ld	b,a
	ld	a,l
	exx
	ld	(hl),l		; raciklus norml (?)
	ex	af,af'
	nop
	jp	(iy)		; +8  ugrs a ciklus elejre
;
;
;      6*n-es blokkmret, 64 szn md
;
;
COL64_6:
	ld	(hl),d		; 6-os blokkmret ciklusok, ismtls NMI rkezsig
	ld	(hl),e
	ld	i,a		; RAM olvass elkszts, I=cm fels bjt
	push	bc
	ex	af,af'		; A reg.= RAM cm als bjt
	ld	(hl),d
	ld	(hl),l
	ret	c
	ld	r,a
	ld	(hl),$DF	; 6/4=1 -> 6-os mdnak megfelel raciklus, ST4=1
	exx
	xor	a
	dec	b
	cp	b
	ccf
	rra
	rra
	rra
	add	a,l
	ld	l,a
	adc	a,h
	sub	l
	ld	h,a
	ex	af,af'
	xor	a
	cp	b
	ccf
	sbc	a,a
	and	c
	or	b
	ld	b,a
	ld	a,l
	exx
	ld	(hl),l		; raciklus norml (?)
	ex	af,af'
	nop
	jp	(iy)		; +8  ugrs a ciklus elejre
;
;
;      4*4 -es blokkmret md megjelentsi fciklusa
;      sszes rajelciklus: 240
;
;
L0281:
	ld	(hl),d		; +7  4-es blokkmret ciklusok, ismtls NMI rkezsig
	ld	(hl),e		; +7
	ld	i,a		; +9  RAM olvass eng., I=cm fels bjt
	push	bc		; +11
	ex	af,af'		; +4  A reg.= RAM cm als bjt
	ld	(hl),d		; +7
	ld	(hl),l		; +7  CBL=1, innen szmtva 34 raciklusra jn az els Y kppont
	ld	iy,L0281	; +14 ciklus
	ld	r,a		; +9  R=cm als bjt
	ld	a,$00		; +7  R++
	exx			; +4  0. sznbjt bersa az utasts vgnl
	xor	a		; +4  itt jelenik meg a 0. sznbjt, a vgn 1. sznbjt bersa
	dec	b		; +4  2. sznbjt, B reg. a blokk magassgt szmolja
	cp	b		; +4  3. sznbjt, B=0 ? CY=0, ha igen
	ccf			; +4  4. sznbjt, CY invertlsa
	rra			; +4  5. sznbjt
	rra			; +4  6. sznbjt
	rra			; +4  7. sznbjt, beforgats A reg. 5.bitjre
	add	a,l		; +4  8. sznbjt, 32-vel nveli a RAM cm als bjtjt, ha kell
	ld	l,a		; +4  9. sznbjt, cm als bjt L-be
	adc	a,h		; +4  10. sznbjt, H nvelse ha van tvitel
	sub	l		; +4  11. sznbjt
	ld	h,a		; +4  12. sznbjt, cm fels bjtja H-ba
	xor	a		; +4  13. sznbjt, ismt a blokk vgnek ellenrzse
	cp	b		; +4  14. sznbjt
	ccf			; +4  15. sznbjt, CY invertlsa
	sbc	a,a		; +4  16. sznbjt, A=0xFF ha blokk vge, egybknt A=0
	and	c		; +4  17. sznbjt, A=C ha blokk vge, egybknt A=0
	or	b		; +4  18. sznbjt, A=B ha nincs blokk vge
	ld	b,a		; +4  19. sznbjt, blokk-magassg szmll betltse
	ld	a,l		; +4  20. sznbjt
	ex	af,af'		; +4  21. sznbjt, RAM cm als bjt A'-be
	nop			; +4  22. sznbjt
	nop			; +4  23. sznbjt
	nop			; +4  24. sznbjt
	nop			; +4  25. sznbjt
	nop			; +4  26. sznbjt
	nop			; +4  27. sznbjt
	nop			; +4  28. sznbjt
	nop			; +4  29. sznbjt
	nop			; +4  30. sznbjt
	nop			; +4  31. sznbjt bersa
	nop			; +4  31. sznbjt megjelense
	jp	L02B5		; +10 ciklus
;
L02B5:
	ld	a,h		; +4  A= RAM cm fels bjtja
	exx			; +4
	jp	(iy)		; +8  ugrs a ciklus elejre
;
;
;
;     RESET s INT utn itt indul a szoftver
;
;
L02B9:
	ld	de,$0101
	exx
	ld	hl,$9000
	ld	sp,hl		; a verem-mveletek a sttuszregisztert fogjk lltani
L02C1:
	ld	(hl),$5A
	ld	(hl),$1A
	jp	L02C1
;
;
;    A belltsokhoz szksges tblzatok
;
;
L02C8:				; paletta cm (als bjt) tblzat
	.db	00h		; 3. paletta (1 = 0001) ?0x80 kellene?
	.db	60h		; 2. paletta (2 = 0010)
	.db	00h		; nem hasznlt
	.db	40h		; 1. paletta (4 = 0100)
;
L02CC:				; tblzat az kpelemdef.-hez
	.db	37h,04h
	.db	27h,06h
	.db	37h,04h
	.db	1Eh,09h
;
IY_TABLA:
	.dw	L0281		; 4*4-es md, 32 szn
	.dw	L0258		; 6*6-os md, 32 szn
	.dw	L0281		; 4*4-es md, 32 szn (??)
	.dw	L0258		; 6*9-es md, 32 szn
	.dw	L0281		; 4*4-es md, 64 szn
	.dw	COL64_6		; 6*6-os md, 64 szn
	.dw	L0281		; 4*4-es md, 64 szn (??)
	.dw	COL64_6		; 6*9-es md, 64 szn
;
.end
